//********ku9 js使用示例(适合1.3.4及以上版本使用)********//

//Js脚本读取支持网络路径和本地路径
//网络路径格式 http://***/***/k-web/ku9/js/***.**?id=***   /k-Web/前为网络路径，如：http://ku/99
//本地路径格式（js文件夹） http://***/***/ku9/js/***.**?id=***
//如需要识别为可时移地址，可在/k-Web/之后并且在/ku9/js/之前添加可时移字符，
//如： http://***/***/k-web/PLTV/ku9/js/***.**?id=***   http://***/***/PLTV/ku9/js/***.**?id=***
//url同时包含/k-web/和/ku9/js/读取网络文件，只包含/ku9/js/读取js文件夹下文件
//分组配置中的js路径为标准网络路径和本地file格式及http://127.0.0.1:9978格式路径；

//识别名称main
function main( item ) {

//获取地址 返回类型String
const url = item.url;

//获取地址后面的请求参数 参数一为请求地址 参数二为要获取的值 返回类型String
var id = item.id;//快速方式
var id = ku9.getQuery( url,  "id" );

//网络请求request（推荐） 返回类型object
//参数一为url:请求地址（String类型）
//参数二为GET或POST（String类型）
//参数三为headers:请求头（object类型）
//参数四为body:请求体（String类型）
//参数五为redirect:重定向地址布尔值（Boolean类型）
//url必填参数，其余可选，type默认为GET，重定向默认为true（需要获取重定向后的地址，填false）
let res = ku9.request( url, "GET" , headers, "***" , false)
let res = ku9.request( url, "POST" , headers, "***" )
let res = ku9.request( url, "POST" , headers)
let res = ku9.request( url, "POST" )
let res = ku9.request( url )
//通过返回的object获取重定向到最后的url
var furl=res.furl
//通过返回的object获取响应状态码
var code=res.code
//通过返回的object获取响应头
var headers=res.headers
//通过返回的object获取响应正文
var body=res.body

//加密库引用示例
const CryptoJS = require( "crypto" );
const jsencrypt = require( "jsencrypt" );
let base64String = "" ; //url Base64编码
let url = CryptoJS.enc.Base64.parse(base64String).toString( CryptoJS.enc.Utf8 );
const response = ku9.request( url );

//get请求方式  headers（json格式）返回类型String
var headers = { 'Content-Type': 'application/x-www-form-urlencoded', 'User-Agent': 'okhttp/3.12.11' }
var field = { requestUrl: url , Headers: headers };
var res = ku9.get( field.requestUrl , field.Headers );
var res = ku9.get( url , headers );
var res = ku9.get( url , null );

//post请求方式  参数一为url  参数二为headers（json格式） 参数三为body 返回类型String
var res = ku9.post( url , headers , "***" );
var res = ku9.post( url , null , "***" );

//getHeaders 获取网络请求返回头部信息 返回类型json格式字符串
//参数一为url:请求地址（String类型）
//参数二为headers:请求头（json格式字符串）
//参数三为redirect:重定向地址布尔值（Boolean类型）
//参数四为GET或POST（String类型）
//参数五为body:请求体（String类型）
//url必填参数，其余可选，type默认为GET，重定向默认为true（需要获取重定向后的地址，填false）
let res = ku9.getHeaders( url, headers , false, "POST", "***" )
let res = ku9.getHeaders( url, headers , true,  "GET" )
let res = ku9.getHeaders( url, headers , false )
let res = ku9.getHeaders( url, headers )
let res = ku9.getHeaders( url)

//openssl AES解密加密
var iv = "JUMxvVMmszqUTeKn";
var key = "ilyB29ZdruuQjC45JhBBR7o2Z8WJ26Vg";
var type ="AES-256-CBC"

//加密：参一加密数据；参二加密类型；参三加密秘钥；参四输出数据类型，0为Base64字符串，1为HEX字符串，默认0；参五加密向量。返回类型String
var enc = ku9.opensslEncrypt( url, enType, key , outputType, iv );
var enc = ku9.opensslEncrypt( url, enType, key , outputType );
var enc = ku9.opensslEncrypt( url, enType, key );
//解密：参一解密数据；参二解密类型；参三解密秘钥；参四输入数据类型，0为Base64字符串，1为HEX字符串，默认0；参五解密向量。返回类型String
var dec = ku9.opensslDecrypt( url, deType, key , inputType, iv );
var dec = ku9.opensslDecrypt( url, deType, key , inputType );
var dec = ku9.opensslDecrypt( url, deType, key );

//rc4解密 参一要解密内容Sting；参二要解密的密码String；参三输入格式int 0为String 1为Hex；参四输出格式int 0为String 1为Hex；参五字符集String（可选，默认UTF-8）
var dec = ku9.rc4Decrypt( url, key, 0 , 1 , "UTF-8" );
var dec = ku9.rc4Decrypt( url, key, 0 , 1 );
//rc4加密 参一要加密内容Sting；参二要加密的密码String；参三输入格式int 0为String 1为Hex；参四输出格式int 0为String 1为Hex；参五字符集String（可选，默认UTF-8）
var enc = ku9.rc4Encrypt( url, key, 0 , 1 , "GBK" );
var enc = ku9.rc4Encrypt( url, key, 0 , 1 );

//sha1加密 参一需要加密的String 返回类型String
var sha1 =ku9.sha1( url )

//sha256加密 参一需要加密的String 返回类型String
var sha256 =ku9.sha256( url )

//sha512加密 参一需要加密的String 返回类型String
var sha512 =ku9.sha512( url )

//setCache 参数一为缓存时定义的名称String 参数二为缓存的值String 参数三为时效long 无返回类型（单位毫秒，0为永久有效，如：时效为1分钟，需传入60000）
ku9.setCache( url , id , 0 )

//getCache 参数为缓存时定义的名称String,根据名称获取对应的缓存值String，返回类型String，过期或者值不存在返回null
var getCache =ku9.getCache( url )

//转md5 参数一为需要转换的String 返回类型String
var md5 =ku9.md5( url )

//是否为json对象 参数一为需要的String 返回类型Boolean
var isJsonObject =ku9.isJsonObject( url )

//是否为json组 参数一为需要的String 返回类型Boolean
var isJsonArray =ku9.isJsonArray( url )

//是否为b64编码 参数一为需的的String 返回类型Boolean
var isBase64 =ku9.isBase64( url )

//b64编码 参数一为需要的String 返回类型String
var encodeBase64 =ku9.encodeBase64( url )

//b64解码 参数一为需要的String返回类型String
var decodeBase64 =ku9.decodeBase64( url )

//解析网址结构 返回类型Object
var uri = ku9.Uri( url );
//获取协议类型 返回String
var Scheme = uri.Scheme;
//获取域名或IP地址 返回int
var Host = uri.Host;
//获取连接的端口号 返回String
var Port = uri.Port;
//获取路径部分，不包含名称及后缀部分 返回String
var Path= uri.Path;
//查询字符串部分，以 ? 开头，通常包含键值对，用于传递参数。 返回String
var Query = uri.Query;
//获取片段标识符，以 # 开头，通常用于指向页面的特定部分或元素。 返回String
var Fragment = uri.Fragment;
//获取完整的路径，包含名称及后缀部分 返回String
var FullPath = uri.FullPath;
//解析url查询参数，生成键值对，返回json格式，如http://123/c.m3u8?id=1&c=k，返回json格式{“c”：“k”}
var Params = uri.Params;

//日期转时间戳，参数一为输入日期字符String，参数二为输入日期格式String，参数三为设置时区String，返回毫秒数long
var time = ku9.toTimestamp( "2024-10-23" , "yyyy-MM-dd" , "Asia/Shanghai" );
var time = ku9.toTimestamp( "2024-10-23" , "yyyy-MM-dd"  );
//时间戳转日期，参数一为13位时间戳（毫秒）long，参数二为输出日期格式String，参数三为设置时区String，返回String
var time = ku9.toDate( 1698019200000 , "yyyy-MM-dd" , "Asia/Shanghai" );
var time = ku9.toDate( 1698019200000 , "yyyy-MM-dd" );
//日期转指定格式的日期，参数一为输入日期字符，参数二为输入日期格式，参数三为输出日期格式，参数四为输出日期加减天数，如：1为加一天，-1为减一天，0或者不传参数为当天，参数五为输入日期时区，参数六为输出日期时区，返回String
var formatDateTime = ku9.formatDateTime( "2024-10-23 21:23:00" , "yyyy-MM-dd HH:mm:ss" ,  "yyyy-MM-dd" , 1 , "Asia/Shanghai" , "Asia/Shanghai" );
var formatDateTime = ku9.formatDateTime( "2024-10-23 21:23:00" , "yyyy-MM-dd HH:mm:ss" ,  "yyyy-MM-dd" , 1 , "Asia/Shanghai" );
var formatDateTime = ku9.formatDateTime( "2024-10-23 21:23:00" , "yyyy-MM-dd HH:mm:ss" ,  "yyyy-MM-dd" , 0 );
var formatDateTime = ku9.formatDateTime( "2024-10-23 21:23:00" , "yyyy-MM-dd HH:mm:ss" ,  "yyyy-MM-dd" );

//websocket 返回类型object
//链接示例：ws://xxx
let ws = ku9.websocket();
//创建连接对象；参一地址（String类型）, 参二请求头（object类型）, 参三连接名称（String类型）
let wsconnect =ws.connect(url, headers, name);
//获取已有连接对象 name:连接名称（String类型）
let wsconnect = ws.get( name );
//判断已有连接 name:连接名称（String类型），返回类型Boolean
let haswsname = ws.has( name );
//发送消息，mes（String类型），二进制数据
wsconnect.send( mes );
//发送消息，mes为二进制数据时转为Hex，参数二必须为true；
wsconnect.send( mes , true );
//关闭连接，code状态码(int类型)，reason为关闭原因（String类型）；
wsconnect.close( 1000 , reason );
//周期任务，name连接名称（String类型），message任务消息（String类型），time执行周期，单位毫秒(long类型)
wsconnect.task( name , message , time );
//周期任务，name连接名称（String类型），message任务消息（String类型），time执行周期，单位毫秒(long类型)；true：消息转Hex（ message为二进制数据时转为Hex 需要填true）
wsconnect.task( name , message , time ,true );
wsconnect.task( name , message , time );
//取消任务，name任务名称（String类型）
wsconnect.removetask( name );
//周期发送的消息
wsconnect.message();
//任务状态码
wsconnect.status();
//任务日志
wsconnect.log();

//返回m3u8 ts切片
let content = "#EXTM3U\n#EXT-X-VERSION:3\n#EXT-X-TARGETDURATION:10\n#EXT-X-MEDIA-SEQUENCE:" + seq + "\n";
    for (var i = 0; i < 3; i++) {
        content += "#EXTINF:10,\n";
        content += "http://123456789/" + id + i + ".ts\n";
    }

return { m3u8: content };
//return JSON.stringify({ m3u8: content });

//返回播放地址
return { url: url };
//return JSON.stringify({ url: url });

//返回播放地址带headers
return { url: url, headers: headers };
//return JSON.stringify({ url: url, headers: headers });

//返回播放地址设置host或映射列表，返回切片时host需设置映射
return { url: url, host: "127.0.0.1" };
return { url: url, host: {"example.com" : "127.0.0.1" , "example.cn" : "127.0.0.2"}};
//return JSON.stringify({ url: url, host: "127.0.0.1" });
//return JSON.stringify({ url: url, host: {"example.com" : "127.0.0.1" , "example.cn" : "127.0.0.2"} });

//通过webview播放
//headres : 请求头，object；设置ua或cookie
//jscode : js代码，String（在页面加载完成后需要执行的js代码）；
return { webview: url, jscode: jscode, headers: headers };
return { webview: url, jscode: jscode };
return { webview: url };

//jscode代码可单独放在app目录下的webviewJscode文件夹下webview_jscode.js文件中，源格式webview://http**** app播放时会自动调用;
//默认读取assets中的webview_jscode.js文件，自定义时更改app目录下的webviewJscode文件夹下webview_jscode.js文件即可；

//headers及host为根据实际情况填写，无顺序要求，返回时标明key名称即可

}